from math import inf


def crea_matrice(m, n):
    M = [None] * m
    for i in range(0, m):
        M[i] = [0] * n
    return M


def floyd_warshall(W):
    n = len(W)
    Matrici = [None] * (n+1)
    Matrici[0] = W
    for k in range(0, n):
        Matrici[k+1] = crea_matrice(n, n)
        for i in range(0, n):
            for j in range(0, n):
                k_in = Matrici[k][i][k] + Matrici[k][k][j]
                k_out = Matrici[k][i][j]
                Matrici[k+1][i][j] = min(k_in, k_out)
    return Matrici[n]


Grafo = [[0, 2.3, 3.3, inf, inf],
         [inf, 0, -2, inf, inf],
         [inf, inf, 0, inf, inf],
         [6.2, inf, inf, 0, 4],
         [inf, 5, inf, -3, 0]]
