def levenshtein(x, y):
    m = len(x)
    n = len(y)
    c = [None] * (m+1)
    for i in range(0, m+1):
        c[i] = [0] * (n+1)
    # gestione dei casi base
    for i in range(0, m+1):
        c[i][0] = i
    for j in range(0, n+1):
        c[0][j] = j
    for i in range(1, m+1):
        for j in range(1, n+1):
            cancellazione = 1 + c[i-1][j]
            inserimento = 1 + c[i][j-1]
            sostituzione = c[i-1][j-1]
            if x[i-1] != y[j-1]:
                sostituzione += 1
            c[i][j] = min(cancellazione, inserimento, sostituzione)
    return c[m][n]
